const { gql } = require('apollo-server-express');

module.exports = gql`

    type User {
        id: String!
        name: String!
        email: String!
        password: String
        phoneNumber: String
        verified: Boolean!
        refreshToken: String
        status: Int!
        avatar: String
        role: Role!
        logs: [Log!]
        sessionAt: String
        expiresAt: DateTime!
        createdAt: DateTime
        updatedAt: DateTime
        deletedAt: DateTime
    }

    extend type Query {
        findAllUsers: [User!]
        findUser(userId: String!): User
    }

    extend type Mutation {
         createUser(roleId: String!, name: String!, password:String!, phoneNumber:String!): registerResponse
         createUserSession(username: String!, password: String!): loginResponse
         verifyPhoneNumber(phoneNumber: String!): smsResponse
    }

    type registerResponse {
        id: String!
        roleId: String!
        username: String!
        phoneNumber: String!
        expiresAt: DateTime!
        createdAt: DateTime!
        updatedAt: DateTime!
    }

    type loginResponse {
        id: String!
        name: String!
        email: String!
        password: String
        phoneNumber: String
        verified: Boolean!
        refreshToken: String
        status: Int!
        avatar: String
        role: Role!
        logs: [Log!]
        sessionAt: String
        expiresAt: DateTime!
        createdAt: DateTime
        updatedAt: DateTime
        deletedAt: DateTime
        jwtToken: String!
    }

    type smsResponse {
        phoneNumber: String!,
        smsCode: Int!
    }

`;